$('#directory-search-form').live('submit', function() {
    var searchField = $('#directory-search-page #directory-search-search')
    var directory = $.mobile.activePage.find('#directory-search-form #directory-search-directory').val()
    if ( searchField.val() != "" || directory === "department" )  {
        directorySearch()        
    }
    
    return false
})

function directorySearch() {
    // kill keyboard
    if( window.document.activeElement ){
    	$( window.document.activeElement || "" ).add( "input:focus, textarea:focus, select:focus" ).blur();
    }
    		
    $.mobile.showPageLoadingMsg();
    var form = $.mobile.activePage.find('#directory-search-form')
    var searchActionUrl = form.attr('action')
    var formData = form.serialize()
    var results = $.mobile.activePage.find('#results')
    
    // empty, then load - fixes footer jump
    results.empty()
    results.load(searchActionUrl, formData, function() {
        $.mobile.hidePageLoadingMsg()
        results.listview("refresh").trigger("updatelayout")
    })
}

$('#directory-search-page').live('pageremove', function(e) {
    if ($.mobile.activePage.attr('id').indexOf("directory-") == 0){
        // Don't remove unless navigation is away from Directory
        e.preventDefault()
    }
})

$('a.directory-search-button').live('click', function() {
    // set the directory
    $.mobile.activePage.find('#directory-search-form #directory-search-directory').val($(this).attr('id'))

    var results = $.mobile.activePage.find('#results')
    results.empty()

    var searchField = $('#directory-search-page #directory-search-search')
    
    if ( $(this).attr('id') === "department") {
        // for department - blank the search box an show all
        searchField.val("")
        directorySearch()
    }
    else
    // redo the search based on the directory chosen
    if ( searchField.val() != "" ) {
        directorySearch()        
    }
    
    return true
})

// on page show, check the logged in state
$('#directory-search-page').live('pagebeforeshow', function( event, ui ) {
    var url = "/app/Mshell/is_logged_in"
    $.getJSON( url, function(json) {
        var loggedIn = json.logged_in
        
        var showingSignIn = $('#directory-search-page #directory-sign-in-menu').length > 0
        
        if ((loggedIn && showingSignIn) || (!loggedIn && !showingSignIn)) {
            // reload
            $.mobile.changePage( "/app/Mshell/launch_mapp?id=directory", { transition: 'fade', reloadPage: true } )
        }
    })
    
})